<template>
  <div
    class="product-slug pt-4 pb-5 animate__animated animate__fadeIn animate__faster"
    v-if="product"
  >
    <div class="container">
      <div class="row mt-3">
        <div class="col-md-6 position-relative">
          <h1
            class="name text-center text-md-left my-0 d-md-none font-weight-bold"
          >
            {{ product.nombre }}
          </h1>

          <!-- Gallery -->
          <Gallery :product="product" />

          <section class="price text-center mt-5 d-md-none">
            <div
              class="with-offer d-flex justify-content-center align-items-center"
              v-if="product.precio_descuento"
            >
              <h3 class="offer my-0 mr-3 text-primary">
                {{ price(product.precio_real) }}
              </h3>
              <h3 class="real my-0">{{ price(product.precio_descuento) }}</h3>
            </div>
            <div v-else>
              <h3 class="real my-0">{{ price(product.precio_real) }}</h3>
            </div>
          </section>

          <section
            class="d-flex justify-content-center justify-content-md-start d-md-none mt-2"
          >
            <AddToCart :product="product" />
          </section>
        </div>

        <div class="col-md-6 pr-lg-5">
          <article class="info card border-0 shadow-card mt-3 mt-md-0 px-3">
            <div class="card-body pt-3 pt-md-1">
              <div class="border-bottom">
                <div class="position-relative">
                  <span
                    class="agotado d-inline-block bg-danger text-white text-uppercase px-2 mb-2"
                    v-if="
                      product.stok_real == 0 || product.estado == 'Desactivado'
                    "
                    >Agotado</span
                  >
                </div>

                <nuxt-link
                  :to="{
                    name: 'productos-categorias-slug',
                    params: { slug: product.data.slug },
                  }"
                  class="category my-0"
                >
                  <span class="text-primary">
                    <i class="fas fa-chevron-right" aria-hidden="true"></i>
                  </span>
                  <span>{{ product.data.nombre }}</span>
                </nuxt-link>

                <h1
                  class="name text-center font-weight-bold text-md-left mt-3 d-none d-md-block"
                >
                  {{ product.nombre }}
                </h1>

                <p class="small text-muted my-1">
                  {{ product.descripcionCorta }}
                </p>

                <section class="large-description font-weight-light mt-3">
                  <div v-html="product.descripcionLarga"></div>
                </section>
              </div>

              <section class="price mt-3 d-none d-md-block">
                <div class="with-offer" v-if="product.precio_descuento">
                  <h3 class="real my-0">{{ price(product.precio_real) }}</h3>
                  <h3 class="offer my-0">
                    {{ price(product.precio_descuento) }}
                  </h3>
                </div>
                <div v-else>
                  <h3 class="real my-0">{{ price(product.precio_real) }}</h3>
                </div>
              </section>

              <section
                class="d-none d-md-flex justify-content-center justify-content-md-start mt-3"
              >
                <AddToCart :product="product" />
              </section>
            </div>
          </article>
        </div>
      </div>
    </div>

    <div class="container mt-3 mt-md-5">
      <div class="row">
        <div class="col mt-4">
          <ProductsList
            title="Productos relacionados"
            :products="relatedProducts"
            :filters="false"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { appConfig } from "../../app-config.js";

import { priceFormat } from "@/utils/price-format.js";

import GetGetProductoSlug from "@/graphql/queries/productos/GetGetProductoSlug.gql";
import GetProductoCategoria from "@/graphql/queries/productos/GetProductoCategoria.gql";

import SectionTitle from "@/components/global/SectionTitle";
import AddToCart from "@/components/products/cards/AddToCart";
import ProductsList from "@/components/products/ProductsList";
import Gallery from "@/components/products/Gallery";

export default {
  data() {
    return {
      slug: this.$route.params.slug,
      relatedProducts: [],
    };
  },
  head() {
    // Se utiliza https://vue-meta.nuxtjs.org/

    let title = "", // Graph
      description = appConfig.openGraph.descripcion, // env
      url = appConfig.openGraph.urlWeb,
      image = appConfig.openGraph.logo,
      slug = this.slug,
      keywords = appConfig.openGraph.keywords,
      whatsappImg = appConfig.openGraph.logo;

    // Se sobreescribe con los datos del post
    if (this.product) {
      description = this.product.descripcionCorta
        ? this.product.descripcionCorta
        : appConfig.openGraph.descripcion;
      title = this.product.nombre;
      keywords = this.product.keywords;
      image = this.product.open_graph.url;
      whatsappImg = this.product.open_graph.url;
    }

    return {
      title: title,
      link: [
        {
          rel: "stylesheet",
          href: "https://cdnjs.cloudflare.com/ajax/libs/froala-editor/3.2.6/css/froala_editor.min.css",
        },
      ],
      meta: [
        { vmid: "abrk", name: "keywords", content: keywords },
        { vmid: "abrd", name: "description", content: description },

        // Twitter Card
        { vmid: "tc", name: "twitter:card", content: "summary" },
        { vmid: "tt", name: "twitter:title", content: title },
        { vmid: "td", name: "twitter:description", content: description },
        // image must be an absolute path
        { vmid: "ti", name: "twitter:image", content: image },

        // Facebook OpenGraph
        { vmid: "ot", property: "og:title", content: title },
        { vmid: "os", property: "og:site_name", content: title },
        { vmid: "ot", property: "og:type", content: "website" },
        { vmid: "oi", property: "og:image", content: image },
        { vmid: "od", property: "og:description", content: description },
        { vmid: "ou", property: "og:url", content: `${url}/productos/${slug}` },

        // Whatsapp OpenGraph
        { vmid: "wt", property: "og:title", content: title },
        { vmid: "ws", property: "og:site_name", content: title },
        { vmid: "wt", property: "og:type", content: "website" },
        { vmid: "wi", property: "og:image", content: whatsappImg },
        { vmid: "wd", property: "og:description", content: description },
        { vmid: "wu", property: "og:url", content: `${url}/productos/${slug}` },
      ],
    };
  },
  async asyncData({ params, app, error }) {
    let apollo = app.apolloProvider.defaultClient;

    try {
      let response = await apollo.query({
        query: GetGetProductoSlug,
        variables: {
          slug: params.slug,
        },
      });

      app.store.commit("SET_LOADER", false);

      return {
        product: response.data.GetGetProductoSlug,
      };
    } catch (e) {
      error({ statusCode: 404 });

      app.store.commit("SET_LOADER", false);
    }
  },
  mounted() {
    if (this.product) {
      this.getRelatedProducts();
    }
  },
  components: {
    SectionTitle,
    AddToCart,
    ProductsList,
    Gallery,
  },
  methods: {
    price(val) {
      return priceFormat(val);
    },
    async getRelatedProducts() {
      let response = await this.$apollo.query({
        query: GetProductoCategoria,
        variables: {
          slug: this.product.data.slug,
          number_paginate: 12,
          page: 1,
          estado: "1",
        },
      });

      this.relatedProducts = response.data.GetProductoCategoria.data.filter(
        (item) => item.id != this.product.id
      );
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~/assets/scss/variables";

.product-slug {
  .border-bottom {
    border-bottom: 2px solid rgba($primary, 0.5) !important;
  }

  .name {
    font-size: 1.3em;

    @media (min-width: 768px) {
      font-size: 1.5em;
    }
  }

  .category {
    color: $dark;
    font-size: 0.9rem;

    &:hover {
      color: $primary;
      text-decoration: none;
    }
  }

  .large-description {
    line-height: 1.1rem;
  }

  .price {
    h3 {
      font-size: 2rem;
      font-weight: 700;
      color: $dark;
      margin: 0;
    }

    .with-offer {
      .real {
        font-size: 1.3rem;
        color: rgba($dark, 0.8);
        text-decoration: line-through;
      }
    }
  }

  .add-to-cart {
    max-width: 220px;
  }
}
</style>
